﻿package{
	
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.ui.Keyboard;
	import flash.utils.Timer;
	import flash.display.StageQuality;
	
	import org.papervision3d.cameras.Camera3D;
	import org.papervision3d.lights.PointLight3D;
	import org.papervision3d.objects.DisplayObject3D;
	import org.papervision3d.render.BasicRenderEngine;
	import org.papervision3d.scenes.Scene3D;
	import org.papervision3d.view.Viewport3D;
	
	
	public class IntuitiveDrawer extends Sprite
	{
		
		// Dessin
		private var line:Sprite;
		private var l:Sprite;
		private var lineCopy:Sprite;
		private var lineStack:Array;
		private var isDrawin:Boolean = false;
		
		// Papervision
		private var viewport:Viewport3D;
		private var scene3d:Scene3D;
		private var camera:Camera3D;		
		private var renderer:BasicRenderEngine;
		private var defaultZoom:int = 110;
		private var fps:FirstPersonCamera3D;
		private var rotator:RevoDraw;
		
		public function IntuitiveDrawer():void
		{
			stage.addEventListener(MouseEvent.MOUSE_DOWN,startDessine);
			stage.addEventListener(MouseEvent.MOUSE_UP,stopDessine);
			
			init();
					
		}
		private function init():void
		{
			stage.quality = StageQuality.MEDIUM;
			scene3d = new Scene3D();
			camera = new Camera3D();
			camera.zoom = defaultZoom;
			
			renderer = new BasicRenderEngine();
			viewport = new Viewport3D(stage.stageWidth, stage.stageHeight);
			addChild(viewport);
			
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}
			
		private function startDessine(e:MouseEvent):void
		{
			line = new Sprite();
			addChild(line);
			lineStack = new Array();
			line.graphics.lineStyle(3, 0x0C78C8, 1);
			line.graphics.moveTo(e.stageX,e.stageY);
			
			//dessine l'axe central
			l = new Sprite();
			addChild(l);
			l.graphics.lineStyle(.1, 0xffffff, .6);
			
			for(var i:int = 0; i < stage.stageHeight; i+=4){
				l.graphics.moveTo(stage.stageWidth/2, i+1);
				l.graphics.lineTo(stage.stageWidth/2, i+3);
			}
			
			stage.addEventListener(MouseEvent.MOUSE_MOVE,dessine);
		}
		
		
		private function dessine(e:MouseEvent):void
		{
			isDrawin= true;
			
			if(line != null)
			{
				//if(lineStack.length < 30){
					line.graphics.lineTo(e.stageX,e.stageY);
					addChild(line);
					lineStack.push(new Array(e.stageX,e.stageY));
				//}
				
				//réduit le nb de points dans le array s'ils sont trop rapprochés
				if(lineStack.length>3){
					if(Math.abs(e.stageX - lineStack[lineStack.length-2][0]) < 4 || Math.abs(e.stageY - lineStack[lineStack.length-2][1]) < 4){
						lineStack.pop();
					}			
				}
			}
		}
		
		
		private function stopDessine(e:MouseEvent):void
		{
			//trace(lineStack.length);
			stage.removeEventListener(MouseEvent.MOUSE_MOVE,dessine);
			isDrawin = false;
			removeChild(l);
			if(line != null)
			{
				lineStack.push(new Array(e.stageX,e.stageY));
				removeChild(line);
				line = null;
				
				
				if(lineStack.length > 3){
					makeMeshRotator();
				}
			}
			
			fps = new FirstPersonCamera3D;			
			fps.initialize(viewport, .02,.2);
			fps.focus = 24;
			fps.mode = "auto";
			fps.moveBounds = {front:1000, back:-1000, left:-1000, right:1000};
			fps.mapKeys(FirstPersonCamera3D.WASD_AND_ARROWS);
			
			
		}
		
		private function makeMeshRotator()
		{
			//clean la scène si qqch
			if (rotator) rotator.destroy();
			scene3d.removeChildByName("mesh");
			
			//construit le mesh en fonction du tracé
			rotator = new RevoDraw(lineStack, stage.stageWidth, stage.stageHeight);
			rotator.triangleMesh3D.name = "mesh";
			scene3d.addChild(rotator.triangleMesh3D);
		}
		

		private function onEnterFrame(e:Event)
		{
			if(rotator){
		
				//la rotation se fait dans la classe RevoDraw
				rotator.updateMesh(stage.stageWidth/2 - mouseX, stage.stageHeight/2 - mouseY);
			}
			
			//Rendu!
			if(rotator){
				if(fps.z != -1000){
					fps.look(.007);
				} else {
					fps.look(0);
				}
				renderer.renderScene(scene3d, fps, viewport);
			
			} else {
				renderer.renderScene(scene3d, camera, viewport);
			}
			
			if(isDrawin) renderer.renderScene(scene3d, camera, viewport);
			
		}
	}
}