﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.geom.Point;
	
	import org.papervision3d.core.geom.AnimatedMesh3D;
	import org.papervision3d.core.geom.TriangleMesh3D;
	import org.papervision3d.core.geom.renderables.Triangle3D;
	import org.papervision3d.core.geom.renderables.Vertex3D;
	import org.papervision3d.core.math.NumberUV;
	import org.papervision3d.core.proto.MaterialObject3D;
	import org.papervision3d.materials.ColorMaterial;
	import org.papervision3d.materials.WireframeMaterial;
	import org.papervision3d.materials.special.CompositeMaterial;
	import org.papervision3d.objects.DisplayObject3D;

	
	public class RevoDraw
	{
		
		public static var mesh:TriangleMesh3D;
		private var material:ColorMaterial;
		
		private var matCom:CompositeMaterial;
		private var col:uint;
		
		private var stack:Array;
		private var stageW:int;
		private var stageH:int;
		
		private var numCols:int;
		private var numRows:int;
		
		private var t1:Triangle3D;
		private var t2:Triangle3D;
		
		
		
		
		public function RevoDraw(_stack:Array, _stageW:int, _stageH:int):void
		{
			stageW = _stageW;
			stageH = _stageH;
			stack = _stack;			
				
			numRows = stack.length;
			//numCols = 10;
			numCols = 3 + Math.round(200/stack.length);
			
			var vertices:Array = []; 
			var index0:int = 0;
			//création du BON nombre de vertex(vides)
			
			for (var v:int = 0; v < ( numRows + 1 ) * ( numCols + 1); v++) {
				vertices[v] = new Vertex3D();
				index0++;
			}
	
			trace("index0: "+index0);
			//trace("vertices: " + vertices.length);
			
			//création du materiau
			var material:ColorMaterial = new ColorMaterial(0xffffff, .5);
			material.doubleSided = true;
			
			matCom = new CompositeMaterial();
			matCom.addMaterial(material);
			matCom.addMaterial( new WireframeMaterial(0x000000, .5));
			
			matCom.doubleSided = true;
			
			//lancement des fonctions constructices!
			updateVertices(vertices);
			mesh = makeTriangleMesh3DFromVertices(vertices);
			
		}
		
		public function updateMesh(posx:int, posy:int):void
		{	
			//mesh.rotationY += .5;
			mesh.rotationY += posx/100;
			//mesh.rotationX += posy/100;
			
			//updateVertices(mesh.geometry.vertices);
		}
		
		public function destroy():void
		{
			mesh = null;
		}
		
		public function updateVertices(verts:Array):void
		{
			var index:int = 0;
			
			// assignation de position de la première rangée de points
			/*for (var i:int = 0; i <= numCols; i++)
			{
				var pt:Point = circle(rotation, stack[0][0]-stageW/2);
				verts[index].x = pt.x
				verts[index].y = stack[0][1];
				verts[index].z = pt.y;
				
				index++;
			}*/
			
			var rotation:Number = 0;
			var rotationStep:Number = 1/numCols * (Math.PI*2);
			
			//var index =0;
			// assignation de position du reste des points
			for (var r:int = 0; r < numRows; r++)
			{
				for (var c:int = 0; c <= numCols; c++)
				{			
					//circle fonction qui s'occupe de la rotation autour de l'axe central
					var _pt:Point = circle(rotation, stack[r][0]-stageW/2);
					verts[index].x = _pt.x
					verts[index].y = -stack[r][1];
					verts[index].z = _pt.y;
					
					index++;
					rotation += rotationStep;
				}
				
			}
			trace("index: "+ index);
			trace("----------");
			trace("numRows: "+numRows);
			trace("numCols: "+numCols);
			trace("-------------------");
		}
		
		private function circle(_radians:Number, _radius:Number):Point
		{
			_radians -= Math.PI/2;
			var x:Number = _radius * Math.cos(_radians);
			var y:Number = _radius * Math.sin(_radians);
			return new Point(x,y);
		}
		
		private function makeTriangleMesh3DFromVertices($verts:Array):TriangleMesh3D
		{
			//trace("longeur brut: "+$verts.length);
			
			var index2:int = 0;
			var faces:Array = [];
			
			var _mesh:TriangleMesh3D = new TriangleMesh3D(matCom, $verts, faces);
			
			for (var y:int = 0; y < (numRows); y++)
			{
				/*
				C.--B
				| / |
				A.--D
				*/
				
				for (var x:int = 0; x <= (numCols); x++)
				{
					// création du triangle - ABC
					var va:int = (y+0)*numCols + (x+0);
					var vb:int = (y+1)*numCols + (x+1);
					var vc:int = (y+1)*numCols + (x+0);
					
					var vArr1:Array = [ $verts[va], $verts[vb], $verts[vc] ];
					
					if(x < numCols){
						t1 = new Triangle3D(_mesh, vArr1); 
						faces.push( t1 ); 
						
						//Merci Quand même Gaël! mais là ça commence à bien faire!
						//toutes les facettes qui sont composées par des VERTEX null sont ignorées
						if ( $verts[va].y == 0 || $verts[vb].y == 0 || $verts[vc].y == 0 ){
							faces.pop();
						}
					}
					
					// création du triangle - ADB
					var vd:int = (y+0)*numCols + (x+1);
										
					var vArr2:Array = [ $verts[va], $verts[vd], $verts[vb] ];
					
					if(x < numCols ){
						t2 = new Triangle3D(_mesh, vArr2); 
						faces.push( t2 );
					
						if( $verts[va].y == 0 || $verts[vd].y == 0 || $verts[vb].y == 0){
							faces.pop();
						}					
					}
					
					index2++;			
				}
			}	
			
			trace("index2: "+index2);
			trace("/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-");
			
			return _mesh;			
		}
		
		public function get triangleMesh3D():TriangleMesh3D
		{
			mesh.y = stageH/2;
			return mesh;
		}
	}
}